// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial use without permit.                                *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************
#include <baselib/all.h>

#include <conio.h>
#include <dos.h>

#include "biosdefs.h"
#include "mouse.h"


void BIOSBeep()
{
  putch(0x7);
}

unsigned BIOSHarddiskCount()
{
  unsigned char far *c=(unsigned char far *)MK_FP(0x40,0x75);
  return (int)*c;
}

bool BIOSGetPartitionTable(unsigned char hdnr,PartitionTableNeu *t)
{
  return BIOSLoadSectorLBA(hdnr,0,(Sector*)t);
}

bool BIOSGetPartitionTableExt(unsigned char hdnr,
                              dword lbaADR,
                              PartitionTableNeu *t)
{
  return BIOSLoadSectorLBA(hdnr,lbaADR,(Sector*)t);
}

bool _old_BIOSGetSector(unsigned char hdnr,
                   byte head, zylsec zyl,
                   Sector *sector)
{
  REGPACK r;

  r.r_bx=FP_OFF(sector);
  r.r_es=FP_SEG(sector);
  r.r_cx=zyl; // zyl 0 sektor 1
  r.r_dx=head*256|hdnr;
  r.r_ax=0x0201;
  intr(0x13,&r);
  if (r.r_flags&1)
  {
    return false;
  }
  return true;
}

bool BIOSWriteBootMgrToHead0(int hdnr,const char far *buf,
                             int byteLen)
{
  REGPACK r;

  int sectorLen=((byteLen-1)/512)+1;
  if (sectorLen>80)
    return false;

  assert(sectorLen<=MAX_SECTORLEN);

  r.r_ax=0x0300|sectorLen; // write(3) 2 sektoren
  r.r_cx=0x0002; // sector 2!! / cyl 0
  r.r_dx=hdnr; // platte0 seite 0
  r.r_bx=FP_OFF(buf);
  r.r_es=FP_SEG(buf);
  intr(0x13,&r);

  if (r.r_flags&1)
  {
    return false;
  }
  return true;
}

bool BIOSWriteMBR(int hdnr,const Sector *buf)
{
  REGPACK r;

  r.r_ax=0x0301; // write(3) 1 sektoren
  r.r_cx=0x0001; // sector 1!! / cyl 0
  r.r_dx=hdnr; // platte0 seite 0  0080h
  r.r_bx=FP_OFF(buf);
  r.r_es=FP_SEG(buf);
  intr(0x13,&r);

  if (r.r_flags&1)
  {
    return false;
  }
  return true;
}

int  saved_mode=3;
word video_offset=0xb800;

void BIOSSetMode(MODE mode)
{
  REGPACK r;
  r.r_ax=0xf00; // get videomode
  r.r_bx=0;
  intr(0x10,&r);
  saved_mode=r.r_ax & 0xff;
  if (saved_mode==MODE_HERC_MONO)
  {
    // am mode 7 nichts aendern
    video_offset=0xb000;
    return;
  }
  r.r_ax=mode; // ah==0
  intr(0x10,&r);

  r.r_ax=0xf00; // get videomode
  r.r_bx=0;
  intr(0x10,&r);
  if ((r.r_ax & 0xff)!=mode)
  {
    // ups, will nicht
    video_offset=0xb000;
  }
}

void BIOSRestoreMode()
{
  REGPACK r;
  r.r_ax=saved_mode; // ah==0
  r.r_bx=0;
  intr(0x10,&r);
}

scr_char screen[80][25];
bool b_was_visible=false;

void BIOSSaveScreen()
{
  REGPACK r;

  #ifdef USE_MOUSE
  b_was_visible=mouse_visible();
  if (b_was_visible)
    mouse_off();
  #endif

  for (int y=0; y<25; y++)
  {
    for (int x=0; x<80; x++)
    {
      r.r_ax=0x0200; // ah==0
      r.r_bx=0;
      r.r_dx=(y<<8)|x; // cursor x=0 y=0
      intr(0x10,&r);
      r.r_ax=0x800;
      r.r_bx=0;
      intr(0x10,&r);
      screen[x][y].zeichen  = (unsigned char) (r.r_ax & 0xff);
      screen[x][y].attribut = (unsigned char) ((r.r_ax>>8) &0xff);
    }
  }
}

void BIOSRestoreScreen()
{
  REGPACK r;

  for (int y=0; y<25; y++)
  {
    for (int x=0; x<80; x++)
    {
      /*if (x==79 && y==24)
      {
        r.r_ax=0x945;
        r.r_bx=0x70;
        r.r_cx=1;
        intr(0x10,&r);
        return;
      }
      */
      r.r_ax=0x0200; // ah==0
      r.r_bx=0;
      r.r_dx=(y<<8)|x; // cursor x=0 y=0
      intr(0x10,&r);
      //r.r_ax=0x1302;
      //r.r_bx=0;
      //r.r_cx=1;
      //r.r_dx=(y<<8)|x;
      const scr_char &s=screen[x][y];
      //r.r_bp=FP_OFF(&s);
      //r.r_es=FP_SEG(&s);
      //intr(0x10,&r);
      r.r_ax=(0x9<<8)|s.zeichen;
      r.r_bx=s.attribut;
      r.r_cx=1;
      intr(0x10,&r);
    }
  }
  #ifdef USE_MOUSE
  if (b_was_visible)
    mouse_on();
  #endif
}

bool BIOSLoadSectorLBA(byte hdnr,dword lbaADR,Sector *b)
{
  REGPACK r;

  r.r_ax=0x4100; // ist die bios erweiterung vorhanden
  r.r_bx=0x55aa;
  r.r_dx=hdnr;
  intr(0x13,&r);

  if (r.r_flags &1)
  {
    r.r_ax=0x800;
    r.r_dx=hdnr;
    intr(0x13,&r);
    // cl AND 0x3f sector_count;
    // dh head_count;
    //;inc     dh
    // f(chs -> lba):= (Cyl*Heads+SelHead)*SectorPerTrack +
    //                    SelectedSector - 1
    r.r_cx&=0x3f;
    r.r_dx=(r.r_dx>>8)&0xff;
    r.r_dx++;
    word sel_sector=(word)(lbaADR%r.r_cx)+1;

    dword zyl_head=lbaADR/r.r_cx;
    word sel_head=(word)(zyl_head%r.r_dx);
    word sel_cyl =(word)(zyl_head/r.r_dx);

    if (sel_cyl>1024)
      return false;

    word   lower8=(sel_cyl << 8) ;
    word   bit56=(sel_cyl>>2);
    bit56&=0xc0;

    zylsec z=lower8 | bit56 | sel_sector;
    return _old_BIOSGetSector(hdnr,(byte)sel_head,z,b);
  }

  struct long_ptr
  {
    word off;
    word seg;
  };

  struct     adrpack
  {
    byte  len;
    byte  reserved;
    word  blockCount;
    long_ptr transferbuffer;
    dword lbalow;
    dword lbahigh;
// 08h  QWORD   starting absolute block number
//              (for non-LBA devices, compute as
//                (Cylinder*NumHeads + SelectedHead) * SectorPerTrack +
//                SelectedSector - 1

  } a;

  r.r_ax=0x4200;
  r.r_dx=hdnr;
  a.len=0x10;
  a.reserved=0;
  a.blockCount=1;
  a.transferbuffer.seg=FP_SEG(b);
  a.transferbuffer.off=FP_OFF(b);
  r.r_ds=FP_SEG(&a);
  r.r_si=FP_OFF(&a);
  a.lbalow=lbaADR;
  a.lbahigh=0;
  intr(0x13,&r);

  if (r.r_flags&1)
      return false;
  return true;
}

void BIOSFat16_Fat12_FindVolLabel(AZString &volLabel,byte hdnr,
                           const BootSectorFAT &bs,dword lba_boot)
{
  volLabel="           ";
  // suche das hauptverzeichnis
  assert(bs.signatur==0xaa55);
  if (bs.signatur!=0xaa55)
    return;
  dword rel_sec=bs.fat_copies*bs.sectors_per_fat+bs.sectors_reserved+lba_boot;
  // rel_sec hat die sectornummer des hauptverzeichnisses
  int main_dir_entries=bs.main_dir_entries;
  Sector *s=new Sector; // lieber aufm heap das ganze, haben wenig stack
  if (!s)
    return;

  memset(s,0,sizeof(Sector));

  DirEntrie *d=NULL;

  while(main_dir_entries)
  {
    if(main_dir_entries%16==0)
    {
      if (!BIOSLoadSectorLBA(hdnr,rel_sec,s))
      {
        delete s;
        return;
      }
      d=s->dir_entries;
      rel_sec++;
    }
    if (d->attribute&FA_LABEL && d->len==0 && d->cluster_ref==0)
    {
      volLabel=AZString(d->name,8); // str leider nicht 0 terminiert
      volLabel+=AZString(d->ext,3);
      break;
    }
    main_dir_entries--;
    d++;
  }
  delete s;
  return;
}
