// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial use without permit.                                *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************

enum LicenceType
{
  EXPIRE_NO,    // registered user
  EXPIRE_UNREG, // unregistered user
  EXPIRE_YES,   // every thing else - failed to load file ...
};

struct ChiffreKey
{
  word r;
};


struct LicenceExpiresNo
{
  dword       random;
  LicenceType type; // EXPIRES_NO
  char        name[29]; //nicht 0-terminiert
};

struct LicenceExpires
{
  dword       random;
  LicenceType type; // EXPIRES_xxx
};

union Licence
{
  char                 _[512]; // sollte nicht groesser als 512 bytes werden
  LicenceExpires       expires;
  LicenceExpiresNo     expiresno;
};

extern Licence licence;

// ok-msgbox
#define MSG_MB_OK 1

class MsgBox: public CWindow
{
  typedef CWindow inherited;
  AZString msg;
  word     type;

  int MaxLen(const char *l);
  int MaxHeight(const char *l);
public:
  MsgBox(const char *l,word _type)
  :CWindow(0,0,MaxLen(l)+2,MaxHeight(l)+2+(_type?2:0))
  ,msg(l)
  ,type(_type)
  {
    SetColor(COL_ALTERT);
  }

  void DrawText(int relx, int rely, const char *txt, byte col=0);

  void Paint();
};

inline bool LicenceCheckDate()
{
  if (licence.expires.type==EXPIRE_NO || licence.expires.type==EXPIRE_UNREG ||
      licence.expires.type==EXPIRE_YES )
    return true;
  MsgBox msgbox("Die Lizendaten sind nicht mehr gltig!\n"
                "Bitte schauen Sie in der Dokumentation oder\n"
                "unter http://www.mrboot.de nach.",MSG_MB_OK);
  msgbox.Center();
  BIOSSaveScreen();
  msgbox.Paint();
  word id=0;

  id=msgbox.Execute();

  BIOSRestoreScreen();
  return false;
}

LicenceType LicenceLoad();

