// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial use without permit.                                *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************
enum PrimLogExt
{
  EXT  =0,
  PRIM =1,
  LOG  =2
};

class PartEntry
{
public:
  byte           hdnr;
  PAR_TYPE       par_type;
  AZString       parTyp;
  AZString       volName;
  PrimLogExt     prim; // 0 ext 1 prim 2 sonst z.b. Floppy
  char           dosName;
  // entrag 0,1,2,3  Partitiontable
  byte           indexInTable;

  PartitionEntry peBootSec; // dieser eintrag zeigt auf den Bootsektor
  dword          lbaADRpeBootSec;

  PartitionEntry peWoher;   // dieser eintrag zeigt auf die Partitionstabelle
                            // mit dem eintrag fuer peBootSec

  dword          lbaADRpeWoher;
  bool           signatur;//traegt der zugehoerige bootsektor die signatur aa55
public:
  PartEntry(byte hdnr,PAR_TYPE type,const char *parTyp, const char *volName,
            PrimLogExt prim,char dosName,
            const PartitionEntry &peBootSec,
            const PartitionEntry &peWoher, byte index,
            dword lbaADRBootsec,dword lbaADRWoher,bool signatur);


  AZString GetTextLong() const;
  AZString GetTextShort() const;
  AZString GetSize() const;
  char     GetDosName()          const { return dosName; }
  int      GetHdnr()             const { return hdnr;    }
  int      GetIndexInTable()     const { return indexInTable; }
  const PartitionEntry & PE()    const { return peBootSec; }
  const PartitionEntry & Woher() const { return peWoher; }
  bool  IsBootAble() const;
};


typedef AZDList <PartEntry> PartEntryList;

class HardDisk
{
  byte nr;
  void AddPartition   (PartEntryList  &peList,PrimLogExt prim,
                       char &lw,
                       const PartitionEntry &peBootSec,
                       const PartitionEntry &peWoher,
                       byte index,unsigned long lba_offset) const;

  void AddPartitionExt(PartEntryList  &peList,char &lw,
                       const PartitionEntry &pe_ext,
                       dword lba_offset,dword next) const;

public:
  HardDisk(byte _nr);
  AZString GetText() const;
  // auf jedem hd-laufwerk erhaelt die erste dos-partition bzw.
  // die mit dem ACTIVE_FLAG den kleinsten buchstaben
  // die funktion haengt alles was nach dos aussieht
  // an die liste an. [ID: 1,4,6 c,b,e und 11h,14h,16h ...
  // liefert den index des eintrag aus der partitionstabelle
  // oder 5 falls nicht gefunden
  byte AddPartitionsFirstDos(PartEntryList &,char &lw) const;

  void AddPartitionsExt (PartEntryList &,char &lw) const;

  // lw wird erhoeht, sollte es eine windows/dos partition sein
  // so nach AddPartitionsFirstDos  AddPartitionsExt
  // noch die uebrig gebliebenen doslw hinzufuegen
  // parameter i ist der index in der partitionstabelle
  // des doslaufwerkes aus AddPartitionsFirstDos
  void AddPartitionsPrimDos(PartEntryList &,char &lw, byte index) const;
};


void FillPeList(PartEntryList &peList);