// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial use without permit.                                *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************
#include <baselib/all.h>

#include <conio.h>

#include "biosdefs.h"
#include "asmdefs.h"
#include "impsett.h"

#include "partentry.h"
#include "mywin.h"

//************************************************************                                         *
//*                                                          *
//* class PartEditWindow                                     *
//*                                                          *
//************************************************************

PartEditWindow::PartEditWindow()
:inherited(PAR_X+2,PAR_Y+1,PAR_W,PAR_H,LB_NOVSCROLLBAR) // window ohne frame
// die liste faengt 1 weiter links an, falls mal
// mehr als 0..9 partitionseintraege moeglich sind
,partEditList   (PAR_X+1,PAR_Y+3,PAR_W+1,PAR_H-2,LB_DEFAULT )
{
}


EditList *PartEditWindow::CreateEditList(int i,
                                         const char entryname[32],
                                         byte  parameter,
                                         const char hiding_map_given[10],
                                         const AZString & hiding_map_possible)
{
  EditList *edl =new EditList;
  if (!edl)
    return NULL;

  ///const PartEntry &pe=lisel.GetPartEntry();

  // platz reserivieren
  //char default_vol[]="                "
  //                   "                ";
  char buf[6];

  sprintf(buf,"%2d: ",i);
  edl->AddCStr(buf);
  edl->AddVStr(AZString(entryname,32));
  edl->AddCStr(" ");
  sprintf(buf,"%02d",parameter);
  edl->AddVInt(buf);
  edl->AddCStr(" ");
//      edl->AddVStr("        ");
  edl->AddCStr("        "); // sollte mal passwort werden
  edl->AddCStr(" ");
//      edl->AddVStr("        ");
  edl->AddCStr("        "); // das auch
  edl->AddCStr(" ");
  //
  const char *src=hiding_map_given;
  AZString myhide;
  for(int i_=0; i_<=10; i_++,src++)
  {
    char c=*src;
    if (!c)
      break;
    if (strchr(hiding_map_possible,c))
      myhide+=c;
  }
  myhide+="             ";
  ((char *)myhide.Text())[10]=0;

  edl->AddVStr(myhide.Text(),hiding_map_possible.Text()); // zu versteckende Laufwerke
  //}
  // else edl->AddCStr("          ");

  edl->AddCStr("   "); // sichtibar im menu
//      edl->AddCStr(" [");
//      edl->AddVFlg(false);
//      edl->AddCStr("]");
  return edl;
}

void PartEditWindow::Init(SelWindow &sw,const PartEntryList & peList)
{
  char buf[6];
  int i=0;

  partEditList.DeleteAll();

  PartEntryList & pel=(PartEntryList &)peList;
  // dies ist der filter string
  hiding_map=" ";
  hiding_map_print="";
  AZString hiding_prim="";

{
  FORALL(pel,PartEntry)
  {
    const PartEntry & pe=it;
    char  c=pe.GetDosName();
    if (c)
    {
      hiding_map+=c;
      hiding_map+=tolower(c);
      if (pe.prim==PRIM)
        hiding_prim+=c; // standarmaessig alle primaere verstecken
      hiding_map_print+=c;
    }
  }
}
  // hiding_map_print darf nicht laenger als das wort verstecken sein
#define print_len 8
  if (hiding_map_print.Len()>print_len)
  {
    char c=hiding_map_print.Text()[hiding_map_print.Len()-1];
    hiding_map_print=AZString(hiding_map_print,print_len-3)+"..";
    hiding_map_print+=c;
  }


  FORALL(sw.partEditList.GetList(),ListItemSelWindow)
  {
    ListItemSelWindow &lisel=it;
    EditList *edl =lisel.GetEditList();
    if (!edl)
    {
      edl=new EditList();
      lisel.SetEditList(edl);
      const PartEntry &pe=lisel.GetPartEntry();

      // platz reserivieren
      char default_vol[]="                "
                         "                ";
      const AZString & str=pe.volName; // volname
      if ( str.Len());
        memcpy(default_vol,str.Text(),
               min((int)sizeof(default_vol),(int)str.Len()) );

      sprintf(buf,"%2d: ",i);
      edl->AddCStr(buf);
      edl->AddVStr(default_vol);
      edl->AddCStr(" ");
      sprintf(buf,"%02d",i);
      edl->AddVInt(buf);
      edl->AddCStr(" ");
//      edl->AddVStr("        ");
      edl->AddCStr("        "); // sollte mal passwort werden
      edl->AddCStr(" ");
//      edl->AddVStr("        ");
      edl->AddCStr("        "); // das auch
      edl->AddCStr(" ");
      //
      AZString myhide;


      // argl kleiner patch
      // c=0 nichts verstecken==alles sichtbar machen
      // c=1 verstecke alle prim
      // c=0x43 verstecke prim.c usw.
      char c=pe.prim==PRIM?pe.GetDosName():1;
      if (pe.par_type==FLOPPYBOOTSEC)
        c=0;
      // wenn logische partition vertecke alle primaere
      // ansonsten verstecke das aktuelle nicht

      // if (dosName) klappt nicht da Down() Up() dann nicht korrekt arbeiten
      //{                     wenn keine dospartition (s.else) dann nicht verstecken

      const char *t=hiding_prim.Text();
      for(int i=0;i<hiding_prim.Len();i++)
      {
        if (c && c!=t[i])
          myhide+=t[i];
      }
      myhide+="             ";
      ((char *)myhide.Text())[10]=0;

        edl->AddVStr(myhide.Text(),hiding_map.Text()); // zu versteckende Laufwerke
      //}
      // else edl->AddCStr("          ");

      edl->AddCStr("   "); // sichtbar im menu
//      edl->AddCStr(" [");
//      edl->AddVFlg(false);
//      edl->AddCStr("]");
    }
    ListItemEditList *li=new ListItemEditList(edl,LISTITEM_PARTEDIT+i);

    if (li)
    {
      partEditList.AddItem(li);
    }
    i++;
  }
  if (i)
    partEditList.SelectItem(0);
}

void PartEditWindow::Paint()
{
  inherited::Paint();
  ::gotoxy(x+1,y+2);
  textattr(COL_HEADLINE);
  //cprintf("Nr Eintrag im Bootmenu              ID "
  //        "Passwort Passwort Verstecken unsichtb.");
  cprintf("Nr Eintrag im Bootmenu              ID "
          "                  Verstecken          ");
  ::gotoxy(x+58,y+3);
  cprintf("(%s)",hiding_map_print.Text());
//  cprintf("Nr Eintrag im Bootmenu              ID "
//          "versteckbare LW.  versteckte Laufwerke");
  partEditList.Paint();
}

bool PartEditWindow::InsertChar(char c)
{
  return partEditList.InsertChar(c);
}

const PartEntry *FindEntry(PartEntryList &peList,
                             const par_partitionentry &en)
{
  FORALL(peList,PartEntry)
  {
    const PartEntry &pe=it();
    // jetzt schauen wir mal was ein en zu bieten hat
    // im prinzip nur die anfangsadresse des bootsektors

    //byte  disk;
    //byte  lower8cyl;
    //byte  sek05cyl67;
    //byte  head;
    //dword lbaADR;
    zylsec s=en.lower8cyl;
    s=(s<<8)|en.sek05cyl67;

    if (en.disk  ==pe.hdnr &&
        s        ==pe.peBootSec.start_zyl &&
        en.head  ==pe.peBootSec.start_head &&
        en.lbaADR==pe.lbaADRpeBootSec)
      return &pe;

  }
  return NULL;
}



