// *********************************************************************
// *                                                                   *
// * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
// *                                                                   *
// * These files are for reference only. You may not use these files   *
// * for commercial use without permit.                                *
// *                                                                   *
// * b@loet.de                                                         *
// *                                                                   *
// * 1.00 2004-07-04                                                   *
// *      first released                                               *
// *                                                                   *
// *********************************************************************
#include <baselib/all.h>

#include <conio.h>

#include "biosdefs.h"
#include "asmdefs.h"
#include "impsett.h"

#include "partentry.h"
#include "mywin.h"
#include "version.h"
#include "licence.h"

SelWindow::SelWindow(PartEntryList &peList,const ImportSetting & im)
:Window(18,0,78-18,PAR_Y-1)
,partEditList(18+2,1,78-18,PAR_Y-1,LB_NOVSCROLLBAR )
{
  if (!im.conf)
    return; // keine konfiguration gefunden

  // einmal durch die peliste um, moegliche zu versteckende
  // laufwerke zu finden
  // dies ist der filter string
  AZString hiding_map=" ";

  FORALL(peList,PartEntry)
  {
    const PartEntry & pe=it;
    char  c=pe.GetDosName();
    if (c)
    {
      hiding_map+=c;
      hiding_map+=tolower(c);
    }
  }
  const par_partitionentry * p=im.entries;
  for (int i=0; i<im.conf->par_partition_entry_count;i++)
  {
    const PartEntry *pe=FindEntry(peList,*p);
    if (pe)
    {
      EditList *edl=PartEditWindow::CreateEditList(i,p->entryname,p->parameter,
                                                   p->hiding_map,
                                                   hiding_map);
      Insert(*pe,edl);
    }
    //wir kennen ja die groesse nicht
    //kann sein, das sich in spaeteren versionen die groesse aendert
    byte *tmp=(byte*)p;
    tmp+=im.conf->par_partition_entry_len;


    p=(const par_partitionentry *)tmp;
  }
}



void SelWindow::Insert(const PartEntry & pe,EditList *edl)
{
  int get=partEditList.GetItemCount();
  if (get==10)
  {
    BIOSBeep();
    return;
  }

  char buf[256];
  sprintf(buf,"%1d: %s",get,pe.GetTextShort().Text());
  ListItemSelWindow *it=new ListItemSelWindow(buf,
                  LISTITEM_SELWINDOW+get,pe,edl);
  if (it)
  {
    partEditList.AddItem(it);
    // partEditList.Paint();
  }

}
                               // baselib/azlist.h
void SelWindow::Delete()
{
 int c=partEditList.GetItemCount();
  if (!c)
    return;
  partEditList.RemoveItem(c-1);
  partEditList.Paint();
}

void SelWindow::Paint()
{
  Window::Paint();
  gotoxy(-1,-1);
  putch(BR_BOTTOM);
  gotoxy(-1,h);
  putch(BR_TOP);
  gotoxy(w,h);
  putch(BR_LEFT);

  partEditList.Paint();
}


const ListItemSelWindow & SelWindow::operator [](int index) const
{
  int count=0;
  const ListItemSelWindowDList &l= partEditList.GetList();
  ListItemSelWindowDList &l2=(ListItemSelWindowDList &)l;

  FORALL(l2,ListItemSelWindow)
  {
    if (count==index)
    {
      return it();
    }
    count ++;
  }
  assert(!index);
  return *(ListItemSelWindow*)(l.First()->Data());
}

void TitelZeile::Paint()
{
  Clear();
  AZString str="Mr. Boot V"VERSION_STR" (c) 2000  http://www.mrboot.de";

  if (LicenceLoad()==EXPIRE_UNREG)
    str+="   (nicht lizenzierte Version)";
  DrawText(0,0,str.Text());
  inherited::Paint();
}

void FussZeile::Paint()
{
  Clear();
  inherited::Paint();
}

