; *********************************************************************
; *                                                                   *
; * (c) 1997-2004 Andreas Ziermann LOET.DE                            *
; *                                                                   *
; * These files are for reference only. You may not use these files   *
; * for commercial use without permit.                                *
; *                                                                   *
; * b@loet.de                                                         *
; *                                                                   *
; * 1.00 2004-07-04                                                   *
; *      first released                                               *
; *                                                                   *
; *********************************************************************

BITS 16
; MBR code
; hier wird unser bootmanager geladen
; und dann gestartet

; watcom dekl
GLOBAL bootsec_start_
GLOBAL bootsec_ends_
; bcc dekl
GLOBAL _bootsec_start
GLOBAL _bootsec_ends

GLOBAL _boot_disk
GLOBAL _boot_seccount
GLOBAL _boot_version

;GLOBAL _hhh_heap

;_STACK segment para public 'STACK'
;        db 08080h dup(33h)
;_STACK ends

;.text
;startup    segment 
;para public 'CODE'
;        assume cs:startup
;_hhh_heap:
;           db 7c00h dup(55h)     ; das ist alles noch heap
;       org 7c00h
        resb 7c00h
boot:
bootsec_start_:
_bootsec_start:
;   proc far
        jmp short m1
        db      'MrBoot'
_boot_version:
        db      '4.20d'
_boot_disk:
        db      80h
_boot_seccount:
        db      08h
m1:     cli                     ;interrupt sperren
        xor     di,di
        mov     ss,di
        mov     sp,7c00h
        sti                     ; stack: 0000:7c00 di:0000
        push    cs
        pop     es              ; laden das ding gleich hinter diesen sektor

        mov     bx,7e00h        ; es:bx to buffer
        mov     cl,02h          ; sektor 2
        mov     ch,0
        mov     dh,00
        mov     dl,[cs:_boot_disk]          ; kopf 0 , disk 0 (80h)
        mov     al,[cs:_boot_seccount]
        call    read_sec        ; call sektoren lesen -> es:bx
                                ; alle sektoren gelesen weiter:

        ;mov     di,7e0h
        ;mov     ax,cs           ; normalerweise 0
        ;add     di,ax
        ;mov     es,di
        mov     dx,80h
        jmp     7e0h:0
        ;mov     ax,7e0h
        ;push    ax
        ;xor     ax,ax
        ;push    ax
        retf
        ;jmp     7e0h:0
        ;jmp     bootstart
        ;db 0eah, 0,0,0e0h,7   ; // jmp 0000:7e00 == 07d0:100
        ;_bootsec_start   endp

writexy;
; proc near
        push    ax
        push    bx
        mov     ax,1300h        ; write string
        mov     bh,0            ; on page 0
        int     10h
        pop     bx
        pop     ax
        ret
;writexy endp

; bx: zieladresse
; dl: festplattennummer
; al: #sektoren
; cl: beginne mit sektor cl
read_sec:
; proc near
        mov     di,0004h        ; max 4x reset_status aufrufen
m00bc:  mov     ah,02h          ; up: read sector
        int     13h             ;
        jnc     m00db           ; cf==1 ->error
        push    ax              ; ax status  ah:status al:errorcode cf==1!
        xor     ah,ah           ; im fehlerfall: up: resetstatus
        int     13h
        dec     di
        pop     ax
        jnz     m00bc           ; wenn jetzt immernoch fehler vorliegen
        mov     bp,str1  ; "cannot read sector!"
        mov     cx,(str2 - str1 )   ; laenge von ^
        ;mov     cx,str2    ; laenge von ^
        mov     dx,1800h        ; zeile 24 spalte 0
        mov     bl,07           ; Attribut=Grau auf Schwarz
        call    writexy         ; write string es:bp , cx

m00d9:  hlt     
        jmp     m00d9           ; HALT????
m00db:  ret
;read_sec endp

str1:   db 'cannot read sector!'
str2:
bootsec_ends_:
_bootsec_ends:
        times 1b0h db 0 ; einfach nur fuellbytes damit die
                        ; gesamtlaenge min 1b0 bytes ist;


;startup    ends
;           end
